<?php
/**
 * Online Learning LMS functions and definitions
 * @package Online Learning LMS
 */

if ( ! function_exists( 'online_learning_lms_after_theme_support' ) ) :

	function online_learning_lms_after_theme_support() {
		
		add_theme_support( 'automatic-feed-links' );

		add_theme_support('woocommerce');
        add_theme_support('wc-product-gallery-zoom');
        add_theme_support('wc-product-gallery-lightbox');
        add_theme_support('wc-product-gallery-slider');
        add_theme_support('woocommerce', array(
            'gallery_thumbnail_image_width' => 300,
        ));

        load_theme_textdomain( 'online-learning-lms', get_template_directory() . '/languages' );

		add_theme_support(
			'custom-background',
			array(
				'default-color' => 'ffffff',
			)
		);

		$GLOBALS['content_width'] = apply_filters( 'online_learning_lms_content_width', 1140 );
		
		add_theme_support( 'post-thumbnails' );

		add_theme_support(
			'custom-logo',
			array(
				'height'      => 270,
				'width'       => 90,
				'flex-height' => true,
				'flex-width'  => true,
			)
		);
		
		add_theme_support( 'title-tag' );

		add_theme_support(
			'html5',
			array(
				'search-form',
				'comment-form',
				'comment-list',
				'gallery',
				'caption',
				'script',
				'style',
			)
		);

		add_theme_support( 'post-formats', array(
			'video',  
			'audio',  
			'gallery',
			'quote',  
			'image',  
			'link',   
			'status', 
			'aside',  
			'chat',   
		) );
		
		add_theme_support( 'align-wide' );
		add_theme_support( 'responsive-embeds' );
		add_theme_support( 'wp-block-styles' );

		require get_template_directory() . '/inc/metabox.php';
		require get_template_directory() . '/inc/homepage-setup/homepage-setup-settings.php';

		if (! defined( 'ONLINE_LEARNING_LMS_DOCS_PRO' ) ){
		define('ONLINE_LEARNING_LMS_DOCS_PRO',__('https://layout.omegathemes.com/steps/pro-online-learning-lms/','online-learning-lms'));
		}
		if (! defined( 'ONLINE_LEARNING_LMS_BUY_NOW' ) ){
		define('ONLINE_LEARNING_LMS_BUY_NOW',__('https://www.omegathemes.com/products/online-learning-wordpress-theme','online-learning-lms'));
		}
		if (! defined( 'ONLINE_LEARNING_LMS_SUPPORT_FREE' ) ){
		define('ONLINE_LEARNING_LMS_SUPPORT_FREE',__('https://wordpress.org/support/theme/online-learning-lms/','online-learning-lms'));
		}
		if (! defined( 'ONLINE_LEARNING_LMS_REVIEW_FREE' ) ){
		define('ONLINE_LEARNING_LMS_REVIEW_FREE',__('https://wordpress.org/support/theme/online-learning-lms/reviews/#new-post/','online-learning-lms'));
		}
		if (! defined( 'ONLINE_LEARNING_LMS_DEMO_PRO' ) ){
		define('ONLINE_LEARNING_LMS_DEMO_PRO',__('https://layout.omegathemes.com/online-learning-lms/','online-learning-lms'));
		}
		if (! defined( 'ONLINE_LEARNING_LMS_LITE_DOCS_PRO' ) ){
		define('ONLINE_LEARNING_LMS_LITE_DOCS_PRO',__('https://layout.omegathemes.com/steps/online-learning-lms-lite/','online-learning-lms'));
		}
		if (! defined( 'ONLINE_LEARNING_LMS_BUNDLE_BUTTON' ) ){
			define('ONLINE_LEARNING_LMS_BUNDLE_BUTTON',__('https://www.omegathemes.com/products/wp-theme-bundle','online-learning-lms'));
		}

	}

endif;

add_action( 'after_setup_theme', 'online_learning_lms_after_theme_support' );

/**
 * Register and Enqueue Styles.
 */
function online_learning_lms_register_styles() {

	wp_enqueue_style( 'dashicons' );

	$online_learning_lms_theme_version = wp_get_theme()->get( 'Version' );
	$online_learning_lms_fonts_url = online_learning_lms_fonts_url();
    if( $online_learning_lms_fonts_url ){
    	require_once get_theme_file_path( 'lib/custom/css/wptt-webfont-loader.php' );
        wp_enqueue_style(
			'online-learning-lms-google-fonts',
			online_learning_lms_wptt_get_webfont_url( $online_learning_lms_fonts_url ),
			array(),
			$online_learning_lms_theme_version
		);
    }

    wp_enqueue_style( 'swiper', get_template_directory_uri() . '/lib/swiper/css/swiper-bundle.min.css');
	wp_enqueue_style( 'online-learning-lms-style', get_stylesheet_uri(), array(), $online_learning_lms_theme_version );

	wp_enqueue_style( 'online-learning-lms-style', get_stylesheet_uri() );
	require get_parent_theme_file_path( '/custom_css.php' );
	wp_add_inline_style( 'online-learning-lms-style',$online_learning_lms_custom_css );

	$online_learning_lms_css = '';

	if ( get_header_image() ) :

		$online_learning_lms_css .=  '
			.header-center{
				background-image: url('.esc_url(get_header_image()).') !important;
				-webkit-background-size: cover !important;
				-moz-background-size: cover !important;
				-o-background-size: cover !important;
				background-size: cover !important;
			}';

	endif;

	wp_add_inline_style( 'online-learning-lms-style', $online_learning_lms_css );

	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}	

	wp_enqueue_script( 'imagesloaded' );
    wp_enqueue_script( 'masonry' );
	wp_enqueue_script( 'swiper', get_template_directory_uri() . '/lib/swiper/js/swiper-bundle.min.js', array('jquery'), '', 1);
	wp_enqueue_script( 'online-learning-lms-custom', get_template_directory_uri() . '/lib/custom/js/theme-custom-script.js', array('jquery'), '', 1);

    // Global Query
    if( is_front_page() ){

    	$online_learning_lms_posts_per_page = absint( get_option('posts_per_page') );
        $online_learning_lms_c_paged = ( get_query_var( 'page' ) ) ? absint( get_query_var( 'page' ) ) : 1;
        $online_learning_lms_posts_args = array(
            'posts_per_page'        => $online_learning_lms_posts_per_page,
            'paged'                 => $online_learning_lms_c_paged,
        );
        $online_learning_lms_posts_qry = new WP_Query( $online_learning_lms_posts_args );
        $online_learning_lms_max = $online_learning_lms_posts_qry->max_num_pages;

    }else{
        global $wp_query;
        $online_learning_lms_max = $wp_query->max_num_pages;
        $online_learning_lms_c_paged = ( get_query_var( 'paged' ) > 1 ) ? get_query_var( 'paged' ) : 1;
    }

    $online_learning_lms_default = online_learning_lms_get_default_theme_options();
    $online_learning_lms_pagination_layout = get_theme_mod( 'online_learning_lms_pagination_layout',$online_learning_lms_default['online_learning_lms_pagination_layout'] );
}

add_action( 'wp_enqueue_scripts', 'online_learning_lms_register_styles',200 );

function online_learning_lms_admin_enqueue_scripts_callback() {
    if ( ! did_action( 'wp_enqueue_media' ) ) {
    wp_enqueue_media();
    }
    wp_enqueue_script('online-learning-lms-uploaderjs', get_stylesheet_directory_uri() . '/lib/custom/js/uploader.js', array(), "1.0", true);
}
add_action( 'admin_enqueue_scripts', 'online_learning_lms_admin_enqueue_scripts_callback' );

/**
 * Register navigation menus uses wp_nav_menu in five places.
 */
function online_learning_lms_menus() {

	$online_learning_lms_locations = array(
		'online-learning-lms-primary-menu'  => esc_html__( 'Primary Menu', 'online-learning-lms' ),
	);

	register_nav_menus( $online_learning_lms_locations );
}

add_action( 'init', 'online_learning_lms_menus' );

add_filter('loop_shop_columns', 'online_learning_lms_loop_columns');
if (!function_exists('online_learning_lms_loop_columns')) {
	function online_learning_lms_loop_columns() {
		$online_learning_lms_columns = get_theme_mod( 'online_learning_lms_per_columns', 3 );
		return $online_learning_lms_columns;
	}
}

add_filter( 'loop_shop_per_page', 'online_learning_lms_per_page', 20 );
function online_learning_lms_per_page( $online_learning_lms_cols ) {
  	$online_learning_lms_cols = get_theme_mod( 'online_learning_lms_product_per_page', 9 );
	return $online_learning_lms_cols;
}

add_filter( 'woocommerce_output_related_products_args', 'online_learning_lms_products_args' );

function online_learning_lms_products_args( $online_learning_lms_args ) {

    $online_learning_lms_args['posts_per_page'] = get_theme_mod( 'online_learning_lms_custom_related_products_number', 6 );

    $online_learning_lms_args['columns'] = get_theme_mod( 'online_learning_lms_custom_related_products_number_per_row', 3 );

    return $online_learning_lms_args;
}

require get_template_directory() . '/inc/custom-header.php';
require get_template_directory() . '/classes/class-svg-icons.php';
require get_template_directory() . '/classes/class-walker-menu.php';
require get_template_directory() . '/inc/customizer/customizer.php';
require get_template_directory() . '/inc/custom-functions.php';
require get_template_directory() . '/inc/template-tags.php';
require get_template_directory() . '/classes/body-classes.php';
require get_template_directory() . '/inc/widgets/widgets.php';
require get_template_directory() . '/inc/pagination.php';
require get_template_directory() . '/lib/breadcrumbs/breadcrumbs.php';
require get_template_directory() . '/lib/custom/css/dynamic-style.php';

function online_learning_lms_remove_customize_register() {
    global $wp_customize;

    $wp_customize->remove_setting( 'display_header_text' );
    $wp_customize->remove_control( 'display_header_text' );

}

add_action( 'customize_register', 'online_learning_lms_remove_customize_register', 11 );

function online_learning_lms_radio_sanitize(  $online_learning_lms_input, $online_learning_lms_setting  ) {
	$online_learning_lms_input = sanitize_key( $online_learning_lms_input );
	$online_learning_lms_choices = $online_learning_lms_setting->manager->get_control( $online_learning_lms_setting->id )->choices;
	return ( array_key_exists( $online_learning_lms_input, $online_learning_lms_choices ) ? $online_learning_lms_input : $online_learning_lms_setting->default );
}
require get_template_directory() . '/inc/general.php';

function online_learning_lms_sticky_sidebar_enabled() {
    $online_learning_lms_sticky_sidebar = get_theme_mod('online_learning_lms_sticky_sidebar', true);
    
    if ($online_learning_lms_sticky_sidebar == false) {
        $online_learning_lms_custom_css = ".widget-area-wrapper { position: relative !important; }";
        wp_add_inline_style('online-learning-lms-style', $online_learning_lms_custom_css);
    }
}
add_action('wp_enqueue_scripts', 'online_learning_lms_sticky_sidebar_enabled');

// NOTICE FUNCTION

function online_learning_lms_admin_notice() { 
    global $pagenow;
    $theme_args = wp_get_theme();
    $meta = get_option( 'online_learning_lms_admin_notice' );
    $name = $theme_args->get( 'Name' );
    $current_screen = get_current_screen();

    if ( ! $meta ) {
        if ( is_network_admin() ) {
            return;
        }

        if ( ! current_user_can( 'manage_options' ) ) {
            return;
        }

        if ( $current_screen->base != 'appearance_page_onlinelearninglms-wizard' ) {
            ?>
            <div class="notice notice-success notice-content">
                <h2><?php esc_html_e('Welcome! Thank you for choosing Online Learning LMS. Let’s Set Up Your Website!', 'online-learning-lms') ?> </h2>
                <p><?php esc_html_e('Before you dive into customization, let’s go through a quick setup process to ensure everything runs smoothly. Click below to start setting up your website in minutes!', 'online-learning-lms') ?> </p>
                <div class="info-link">
                    <a href="<?php echo esc_url( admin_url( 'themes.php?page=onlinelearninglms-wizard' ) ); ?>"><?php esc_html_e('Get Started with Online Learning LMS', 'online-learning-lms'); ?></a>
					<a href="#" class="notice-bundle" id="bundleTrigger"><?php esc_html_e('Get All WP Themes', 'online-learning-lms'); ?></a>
					<div class="bundle-overlay" id="bundlePopup">
						<div class="bundle-modal">
							<span class="close-popup">&times;</span>
							<div class="sale-badge"><?php esc_html_e('🔥 MEGA SALE', 'online-learning-lms'); ?></div>
							<h2><?php esc_html_e('Unlock All Premium WP Themes', 'online-learning-lms'); ?></h2>
							<p> <?php esc_html_e('Unlock the Full Potential of Your Website with Our 70+ WordPress Themes Bundle', 'online-learning-lms'); ?></p>
							<ul>
								<li><?php esc_html_e('✔ Expert Support', 'online-learning-lms'); ?></li>
								<li><?php esc_html_e('✔ Premium Theme ZIP File', 'online-learning-lms'); ?></li>
								<li><?php esc_html_e('✔ Ready-to-Use Website Templates', 'online-learning-lms'); ?></li>
								<li><?php esc_html_e('✔ Demo Content (Included in the file)', 'online-learning-lms'); ?></li>
								<li><?php esc_html_e('✔ Access to the Premium Support Forum', 'online-learning-lms'); ?></li>
							</ul>
							<a href="<?php echo esc_url( ONLINE_LEARNING_LMS_BUNDLE_BUTTON ); ?>" target="_blank" class="bundle-cta"><?php esc_html_e('Get the Bundle Now →', 'online-learning-lms'); ?></a>
						</div>
					</div>
                </div>
                <p class="dismiss-link"><strong><a href="?online_learning_lms_admin_notice=1"><?php esc_html_e( 'Dismiss', 'online-learning-lms' ); ?></a></strong></p>
            </div>
            <?php
        }
    }
}
add_action( 'admin_notices', 'online_learning_lms_admin_notice' );

if ( ! function_exists( 'online_learning_lms_update_admin_notice' ) ) :
/**
 * Updating admin notice on dismiss
 */
function online_learning_lms_update_admin_notice() {
    if ( isset( $_GET['online_learning_lms_admin_notice'] ) && $_GET['online_learning_lms_admin_notice'] == '1' ) {
        update_option( 'online_learning_lms_admin_notice', true );
    }
}
endif;
add_action( 'admin_init', 'online_learning_lms_update_admin_notice' );